/**
 * OpenAPI definition
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { Document } from '../model/document';
import { LevelOneResponse } from '../model/levelOneResponse';
import { ReadingPayload } from '../model/readingPayload';
import { ThreePhaseDendrometer } from '../model/threePhaseDendrometer';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class ServerControllerService {

    protected basePath = 'http://localhost:8080';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * Add a reading to the database
     * 
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public addReading(body: ReadingPayload, observe?: 'body', reportProgress?: boolean): Observable<string>;
    public addReading(body: ReadingPayload, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public addReading(body: ReadingPayload, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public addReading(body: ReadingPayload, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling addReading.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.request<string>('post',`${this.basePath}/api/v1/server/add`,
            {
                body: body,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Delete all readings from database
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public deleteAllReadings(observe?: 'body', reportProgress?: boolean): Observable<string>;
    public deleteAllReadings(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public deleteAllReadings(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public deleteAllReadings(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<string>('delete',`${this.basePath}/api/v1/server/delete/all`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get level one response for a group id and a time range
     * 
     * @param station 
     * @param date 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getLevelOneResponseForGroupAndTimeRange(station: string, date: Date, observe?: 'body', reportProgress?: boolean): Observable<LevelOneResponse>;
    public getLevelOneResponseForGroupAndTimeRange(station: string, date: Date, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LevelOneResponse>>;
    public getLevelOneResponseForGroupAndTimeRange(station: string, date: Date, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LevelOneResponse>>;
    public getLevelOneResponseForGroupAndTimeRange(station: string, date: Date, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (station === null || station === undefined) {
            throw new Error('Required parameter station was null or undefined when calling getLevelOneResponseForGroupAndTimeRange.');
        }

        if (date === null || date === undefined) {
            throw new Error('Required parameter date was null or undefined when calling getLevelOneResponseForGroupAndTimeRange.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (date !== undefined && date !== null) {
            queryParameters = queryParameters.set('date', <any>date.toISOString());
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<LevelOneResponse>('get',`${this.basePath}/api/v1/server/get/lvl1/${encodeURIComponent(String(station))}`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get number of readings by sensor id
     * 
     * @param id 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getNumberOfReadingsBySensorId(id: string, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public getNumberOfReadingsBySensorId(id: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public getNumberOfReadingsBySensorId(id: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public getNumberOfReadingsBySensorId(id: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling getNumberOfReadingsBySensorId.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<number>('get',`${this.basePath}/api/v1/server/get/sensor/count/${encodeURIComponent(String(id))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get readings by sensor name and error type and time range
     * 
     * @param sensorId 
     * @param errorType 
     * @param from 
     * @param to 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getReadingsBySensorIdAndErrorTypeAndTimeRange(sensorId: string, errorType: string, from: Date, to: Date, observe?: 'body', reportProgress?: boolean): Observable<Array<Document>>;
    public getReadingsBySensorIdAndErrorTypeAndTimeRange(sensorId: string, errorType: string, from: Date, to: Date, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Document>>>;
    public getReadingsBySensorIdAndErrorTypeAndTimeRange(sensorId: string, errorType: string, from: Date, to: Date, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Document>>>;
    public getReadingsBySensorIdAndErrorTypeAndTimeRange(sensorId: string, errorType: string, from: Date, to: Date, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (sensorId === null || sensorId === undefined) {
            throw new Error('Required parameter sensorId was null or undefined when calling getReadingsBySensorIdAndErrorTypeAndTimeRange.');
        }

        if (errorType === null || errorType === undefined) {
            throw new Error('Required parameter errorType was null or undefined when calling getReadingsBySensorIdAndErrorTypeAndTimeRange.');
        }

        if (from === null || from === undefined) {
            throw new Error('Required parameter from was null or undefined when calling getReadingsBySensorIdAndErrorTypeAndTimeRange.');
        }

        if (to === null || to === undefined) {
            throw new Error('Required parameter to was null or undefined when calling getReadingsBySensorIdAndErrorTypeAndTimeRange.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (sensorId !== undefined && sensorId !== null) {
            queryParameters = queryParameters.set('sensorId', <any>sensorId);
        }
        if (errorType !== undefined && errorType !== null) {
            queryParameters = queryParameters.set('errorType', <any>errorType);
        }
        if (from !== undefined && from !== null) {
            queryParameters = queryParameters.set('from', <any>from.toISOString());
        }
        if (to !== undefined && to !== null) {
            queryParameters = queryParameters.set('to', <any>to.toISOString());
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Document>>('get',`${this.basePath}/api/v1/server/get/sensor/error/range`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Get readings by sensor name and time range
     * 
     * @param sensorId 
     * @param from 
     * @param to 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getReadingsBySensorIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'body', reportProgress?: boolean): Observable<Array<Document>>;
    public getReadingsBySensorIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<Document>>>;
    public getReadingsBySensorIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<Document>>>;
    public getReadingsBySensorIdAndTimeRange(sensorId: string, from: Date, to: Date, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (sensorId === null || sensorId === undefined) {
            throw new Error('Required parameter sensorId was null or undefined when calling getReadingsBySensorIdAndTimeRange.');
        }

        if (from === null || from === undefined) {
            throw new Error('Required parameter from was null or undefined when calling getReadingsBySensorIdAndTimeRange.');
        }

        if (to === null || to === undefined) {
            throw new Error('Required parameter to was null or undefined when calling getReadingsBySensorIdAndTimeRange.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (sensorId !== undefined && sensorId !== null) {
            queryParameters = queryParameters.set('sensorId', <any>sensorId);
        }
        if (from !== undefined && from !== null) {
            queryParameters = queryParameters.set('from', <any>from.toISOString());
        }
        if (to !== undefined && to !== null) {
            queryParameters = queryParameters.set('to', <any>to.toISOString());
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<Document>>('get',`${this.basePath}/api/v1/server/get/sensor/range`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * 
     * @param sensorId 
     * @param from 
     * @param to 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getReadingsDendrometerByIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'body', reportProgress?: boolean): Observable<Array<ThreePhaseDendrometer>>;
    public getReadingsDendrometerByIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<ThreePhaseDendrometer>>>;
    public getReadingsDendrometerByIdAndTimeRange(sensorId: string, from: Date, to: Date, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<ThreePhaseDendrometer>>>;
    public getReadingsDendrometerByIdAndTimeRange(sensorId: string, from: Date, to: Date, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (sensorId === null || sensorId === undefined) {
            throw new Error('Required parameter sensorId was null or undefined when calling getReadingsDendrometerByIdAndTimeRange.');
        }

        if (from === null || from === undefined) {
            throw new Error('Required parameter from was null or undefined when calling getReadingsDendrometerByIdAndTimeRange.');
        }

        if (to === null || to === undefined) {
            throw new Error('Required parameter to was null or undefined when calling getReadingsDendrometerByIdAndTimeRange.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (sensorId !== undefined && sensorId !== null) {
            queryParameters = queryParameters.set('sensorId', <any>sensorId);
        }
        if (from !== undefined && from !== null) {
            queryParameters = queryParameters.set('from', <any>from.toISOString());
        }
        if (to !== undefined && to !== null) {
            queryParameters = queryParameters.set('to', <any>to.toISOString());
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<ThreePhaseDendrometer>>('get',`${this.basePath}/api/v1/server/get/dendrometer/range`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
